CREATE OR REPLACE TRIGGER DTULTATU_ITEMPRECODIAGER
BEFORE INSERT OR UPDATE OR DELETE
ON ITEMPRECODIAGER FOR EACH ROW
DECLARE
   V_CDTABEPREC VARCHAR2(03);
   V_DTINIVGPREC VARCHAR2(10);
   V_CDPRODUTO VARCHAR2(20);
   V_COUNT NUMBER;
   V_DSCHAVE VARCHAR2(100);
BEGIN
   IF INSERTING OR UPDATING THEN
      V_CDTABEPREC := NVL(:NEW.CDTABEPREC, :OLD.CDTABEPREC);
      V_DTINIVGPREC := TO_CHAR(NVL(:NEW.DTINIVGPREC, :OLD.DTINIVGPREC), 'DD/MM/YYYY');
      V_CDPRODUTO := NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO);
      V_DSCHAVE := V_CDTABEPREC||'|'||V_DTINIVGPREC||'|'||V_CDPRODUTO;
      V_COUNT := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM CTRLATUALTAB
          WHERE NMTABELA = 'ITEMPRECODIAGER'
            AND DSCHAVE = V_DSCHAVE;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         INSERT INTO CTRLATUALTAB
            (NMTABELA, DSCHAVE, DTULTATU)
         VALUES
            ('ITEMPRECODIAGER', V_DSCHAVE, SYSDATE);
      ELSE
         UPDATE CTRLATUALTAB
            SET DTULTATU = SYSDATE
          WHERE NMTABELA = 'ITEMPRECODIAGER'
            AND DSCHAVE = V_DSCHAVE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ITEMPRECODIAGER', NULL, 'CDTABEPREC='||:OLD.CDTABEPREC||';DTINIVGPREC='||:OLD.DTINIVGPREC||';CDPRODUTO='||:OLD.CDPRODUTO||';CDPRPAITABPR='||:OLD.CDPRPAITABPR||';NRDIASEMANPR='||:OLD.NRDIASEMANPR||';HRINIPRECDIA='||:OLD.HRINIPRECDIA||';CDTIPOCONSPD='||:OLD.CDTIPOCONSPD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ITEMPRECODIAGER MODIFY DTULTATUITPD DEFAULT SYSDATE
/